'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _nodeIpc = require('node-ipc');

var _nodeIpc2 = _interopRequireDefault(_nodeIpc);

var _r6rs = require('r6rs');

var _r6rsAsyncIo = require('r6rs-async-io');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_nodeIpc2.default.config.id = 'r6rsasync';
_nodeIpc2.default.config.retry = 1500;
_nodeIpc2.default.config.silent = true;

_nodeIpc2.default.serve();

exports.default = new _r6rsAsyncIo.Library('remote', {
  'remote/start': function remoteStart() {
    _nodeIpc2.default.server.start();
    /* return () => {
      ipc.server.stop();
    }; */
  },
  'remote/listen': function remoteListen(params, callback) {
    if (params == null || params.type != _r6rs.SYMBOL && params.type != _r6rs.STRING) {
      throw new Error('String or symbol expected');
    }
    var eventName = params.value;
    var listener = function listener(data, socket) {
      if (Array.isArray(data)) {
        callback(data);
      } else {
        callback([]);
      }
      _nodeIpc2.default.server.emit(socket, 'ack');
    };
    _nodeIpc2.default.server.on(eventName, listener);
    return function () {
      _nodeIpc2.default.server.off(eventName, listener);
    };
  }
});