#!/usr/bin/env node
'use strict';

var _nodeIpc = require('node-ipc');

var _nodeIpc2 = _interopRequireDefault(_nodeIpc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_nodeIpc2.default.config.id = 'r6rsasyncremote';
_nodeIpc2.default.config.retry = 1500;
_nodeIpc2.default.config.silent = true;
_nodeIpc2.default.config.stopRetrying = 0;

var eventName = process.argv[2];
var args = process.argv.slice(3);

if (eventName == null) {
  console.log('Usage: r6rs-remote eventName args ...');
  process.exit(1);
}

_nodeIpc2.default.connectTo('r6rsasync', function () {
  _nodeIpc2.default.of.r6rsasync.emit(eventName, args);
  _nodeIpc2.default.of.r6rsasync.on('ack', function () {
    process.exit(0);
  });
});

setTimeout(function () {
  console.log('Remote doesn\'t seem to be listening on this event...');
  process.exit(1);
}, 500);